Package org.kie.api.runtime.conf

## Enum QueryListenerOption

- java.lang.Object
- - java.lang.Enum<QueryListenerOption>
  - - org.kie.api.runtime.conf.QueryListenerOption

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<QueryListenerOption>`, `Option`, `SingleValueOption`, `KieSessionOption`, `SingleValueKieSessionOption`, `SingleValueRuleRuntimeOption`

      public enum QueryListenerOption
      extends java.lang.Enum<QueryListenerOption>
      implements SingleValueRuleRuntimeOption

  An enum to configure the session query listener configuration. Query results are collected by a listener class. The "STANDARD" query listener class copies and disconnects fact handles and objects for query results, making them somewhat resilient to some working memory actions. But this copying is costly. For the cases where no concurrency exists between query execution and other working memory actions, a lightweight listener implementation can be used, preventing the copy and improving query performance significantly.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `LIGHTWEIGHT` |
    `STANDARD` |

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static OptionKey<QueryListenerOption>` | `KEY` |
    `static java.lang.String` | `PROPERTY_NAME` | The property name for the clock type configuration

    - ### Fields inherited from interface org.kie.api.runtime.conf.SingleValueRuleRuntimeOption

      `TYPE`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static QueryListenerOption` | `determineQueryListenerClassOption​(java.lang.String option)` |
    `java.lang.String` | `getAsString()` |
    `java.lang.String` | `getPropertyName()`
    `java.lang.String` | `toString()` |
    `static QueryListenerOption` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static QueryListenerOption[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.kie.api.conf.Option

      `propertyName`

    - ### Methods inherited from interface org.kie.api.runtime.conf.SingleValueRuleRuntimeOption

      `type`

- - ### Enum Constant Detail

    - #### STANDARD

          public static final QueryListenerOption STANDARD

    - #### LIGHTWEIGHT

          public static final QueryListenerOption LIGHTWEIGHT

  - ### Field Detail

    - #### PROPERTY_NAME

          public static final java.lang.String PROPERTY_NAME

      The property name for the clock type configuration
      See Also:
        Constant Field Values

    - #### KEY

          public static OptionKey<QueryListenerOption> KEY

  - ### Method Detail

    - #### values

          public static QueryListenerOption[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (QueryListenerOption c : QueryListenerOption.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static QueryListenerOption valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getPropertyName

          public java.lang.String getPropertyName()

      Specified by:
        `getPropertyName` in interface `Option`
      Returns:
        the property name for this option

    - #### getAsString

          public java.lang.String getAsString()

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Enum<QueryListenerOption>`

    - #### determineQueryListenerClassOption

          public static QueryListenerOption determineQueryListenerClassOption​(java.lang.String option)